/* Server.h defines a simple server class template.
 *
 * Author: Joel Adams
 * Date: December 1998
 * Version: 0.9
 */

#ifndef SERVER
#define SERVER

#include "CommunicatorUser.h"
using namespace std;

template <class T>
class Server : public CommunicatorUser<T>
{
 public:
  Server(const string & serviceName, const unsigned short port);
  virtual ~Server();

  virtual void run() = 0;
  virtual void interactWithClient() = 0;

  virtual string className() const;

 protected:

 private:

};


/*******************************************************************
 * Constructor.
 * PRE: serviceName is the name of the service I offer
 *       port is the port at which it is offered.
 * POST: I am ready to run.
 ******************************************************************/
template<class T>
inline Server<T>::Server(const string & serviceName, const unsigned short port)
  : CommunicatorUser<T>()
{
  CommunicatorUser<T>::setCommunicator(new T(serviceName, port));
}


/******************************************************************
 * Destructor.
 * (nothing to do)
 ******************************************************************/
template<class T>
inline Server<T>::~Server()
{}

/*******************************************************
 * className accessor.
 * POST: RV == "Server<T>".
 *******************************************************/
template<class T>
inline string Server<T>::className() const
{
  return "Server<T>";
}

#endif
