/* ServerSocketAddress.h extends the SocketAddress implementation for Servers.
 *
 * Author: Joel Adams
 * Date: December 1998
 * Version: 0.9
 */


#ifndef Server_SOCKET_ADDRESS
#define Server_SOCKET_ADDRESS

#include "SocketAddress.h"
using namespace std;

class ServerSocketAddress : public SocketAddress
{
 public:
  ServerSocketAddress();
  ServerSocketAddress(const string & hostName, const unsigned short port);
  ServerSocketAddress(const Host & host, const unsigned short port);
  ServerSocketAddress(const string & hostName, const Service & service);
  ServerSocketAddress(const Host & host, const Service & service);
  
  virtual ~ServerSocketAddress();

 protected:

 private:

};

inline ServerSocketAddress::ServerSocketAddress()
  : SocketAddress()
{}

inline ServerSocketAddress::ServerSocketAddress(const string & hostName,
					       const unsigned short port)
  : SocketAddress(hostName, port)
{
  SocketAddress::addressInfo()->sin_addr.s_addr = INADDR_ANY;
}

inline ServerSocketAddress::ServerSocketAddress(const Host & host, 
						const unsigned short port)
  : SocketAddress(host, port)
{
  SocketAddress::addressInfo()->sin_addr.s_addr = INADDR_ANY;
}

inline ServerSocketAddress::ServerSocketAddress(const string & hostName, 
						const Service & service)
  : SocketAddress(hostName, service)
{
  SocketAddress::addressInfo()->sin_addr.s_addr = INADDR_ANY;
}

inline ServerSocketAddress::ServerSocketAddress(const Host & host, 
						const Service & service)
  : SocketAddress(host, service)
{
  SocketAddress::addressInfo()->sin_addr.s_addr = INADDR_ANY;
}

inline ServerSocketAddress::~ServerSocketAddress()
{}


#endif

