#include "Client_TLI_Communicator.h"

/*****************************************************************
 * open with (Service, Host)
 * PRE: serviceName holds the name of a valid TCP Service;
 *      hostName is the name of a defined IP host.
 * POST: myServiceInfo == service && myRemoteHost = hostName.
 *****************************************************************/

void Client_TLI_Communicator::open(Service * service,
					 const Host & host)
{
  TLI_Communicator::start(service);

  /* need to put this somewhere */
  if (t_bind(getDescriptor(), 0, 0) < 0)
      fatal("Couldn't bind:");

  TLI_Communicator::setAddressInfo(new ClientSocketAddress(host, *service));
  /* the next function is implemented in UDP or TCP _Client_TLI_Comm */
  connect(); 
}


/*****************************************************************
 * operator= - implements the assignment operator
 * PRE: comm is an object which inherits from Client_TLI_Communicator
 * POST: data members are equal to comm's data memebers.
 *****************************************************************/
Client_TLI_Communicator &Client_TLI_Communicator::operator=(const Client_TLI_Communicator & comm)
{
    TLI_Communicator::operator=(comm);
    return *this;
}


