#include "TCP_Client_TLI_Communicator.h"
#include <strings.h>


/**************************************************
 * connect
 *   establishes a connection to the server
 *   This is called from Client_TLI_Communicator
 * PRE: an endpoint has been allocated
 * POST: a connection has been made, we can now 
 *       talk with the server.
 **************************************************/
void TCP_Client_TLI_Communicator::connect()
{
    struct t_call *pcall;
    pcall = (struct t_call *)t_alloc(getDescriptor(), T_CALL, T_ADDR);

    if (pcall == NULL)
	fatal("t_alloc failed.\n");

    memcpy(pcall->addr.buf, addressInfo()->addressInfo(), 
	   sizeof(struct sockaddr_in));
    pcall->addr.len = sizeof(struct sockaddr_in);

    if (t_connect(getDescriptor(), pcall, 0) < 0)
         fatal("can NOT t_connect.\n");
    t_free((char*)pcall, T_CALL);
}

