/** IterativeServerTCPCommunicator.java
 *  @author Joel Adams
 *  @version 1.0.  Copyright 2000.  All rights reserved.
 */

package cliser;

import cliser.ServerTCPCommunicator;

public class IterativeServerTCPCommunicator extends ServerTCPCommunicator
{
   /** explicit constructor
    *  @params port, an int
    *  POST: my inherited attributes have been initialized.
    */
    public IterativeServerTCPCommunicator(int port)
    {
	super(port);
    }

    /** definition of abstract ServerTCPCommunicator.accept()
     * PRE: Some client is going to connect to me.
     *  @return myself, with mySocket set to the return value of myServerSocket.accept()
     */
    public TCPCommunicator accept()
    {
      try
      {
	  this.setSocket( this.getServerSocket().accept() );
	  this.initReaderAndWriter();
	  //  System.err.println("ServerTCPCommunicator.accept():"
	  //			     + " using socket " + this.getSocket() );
      }
      catch (Exception e)
      {
	System.err.println(e); System.exit(1);
      }
      return this;
    }
}
