/** UDPCLient.java
 *  @author Joel Adams
 *  @version 1.0.  Copyright 2000.  All rights reserved.
 */

package cliser;

import cliser.Client;
import cliser.ClientUDPCommunicator;

abstract public class UDPClient extends Client
{
    /** explicit communicator
     *  @params service, a String naming my service
     *  @params remoteHost, a String naming my remote host
     *  @params port, an int specifying the port I will use
     * POST: my (inherited) instance variables have been initialized.
     */
    public UDPClient(String service, String remoteHost, int port)
    {
	super(service, remoteHost, port);
    }

    /** definition of abstract Client.initCommunicator()
     *  PRE: myServer and myPort are initialized.
     *  @return a new ClientUDPCommunicator initialized
     *     for myServer and myPort.
     */
    protected Communicator initCommunicator()
    {
	return new ClientUDPCommunicator( this.getServer(),
	                                  this.getPort() );
    }
}


