/** UDPServer.java
 *  @author Joel C. Adams
 *  @version 1.0.  Copyright 2000.  All rights reserved.
 */

package cliser;

import cliser.Server;
import cliser.ServerUDPCommunicator;

abstract public class UDPServer extends Server
{
    /** explicit communicator
     *  @params service, a String naming my service
     *  @params port, an int specifying the port I will use
     * POST: my (inherited) instance variables have been initialized.
     */
    UDPServer(String service, int port)
    {
	super(service, port);
    }

    /** definition of abstract CommunicatorUser.initCommunicator()
     *  PRE: myPort has been initialized.
     *  @return a new ServerUDPCommunicator initialized using myPort
     */
    protected Communicator initCommunicator()
    {
	return new ServerUDPCommunicator( this.getPort() );
    }
}
